cdac.medinfo.sdk.hl7282.baselibs.segments

## Class OVR

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.segments.Segment
  - - cdac.medinfo.sdk.hl7282.baselibs.segments.OVR

- All Implemented Interfaces:
    ISegment

      public class OVR
      extends Segment

  OVR - Override Segment

  This segment allows a sender to override specific receiving application's business rules to allow for processing of a message that would normally be rejected or ignored.

  Represents an HL7 OVR message segment. This segment has the following fields:

  OVR-1: Business Rule Override Type (CWE)Optional
  OVR-2: Business Rule Override Code (CWE)Optional
  OVR-3: Override Comments (TX)Optional
  OVR-4: Override Entered By (XCN)Optional
  OVR-5: Override Authorized By (XCN)Optional

  This class provides mechanism to validate message against HL7 v 2.8.2 standard. The class provides accessors & mutators for the elements mentioned above. The class has validate method which validates Message against HL7 v 2.8.2 standard.

  User can also create Segment through `SegmentFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `OVR()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `CWE` | `getbusinessRuleOverrideCode()` Retrieves the Business Rule Override Code.
    `CWE` | `getbusinessRuleOverrideType()` Retrieves the Business Rule Override Type.
    `XCN` | `getoverrideAuthorizedBy()` Retrieves the Override Authorized By.
    `TX` | `getoverrideComments()` Retrieves the Override Comments.
    `XCN` | `getoverrideEnteredBy()` Retrieves the Override Entered By.
    `void` | `setbusinessRuleOverrideCode(CWE objbusinessRuleOverrideCode)` Sets the Business Rule Override Code.
    `void` | `setbusinessRuleOverrideCode(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Sets the Business Rule Override Code.
    `void` | `setbusinessRuleOverrideType(CWE objbusinessRuleOverrideType)` Sets the Business Rule Override Type.
    `void` | `setbusinessRuleOverrideType(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Sets the Business Rule Override Type.
    `void` | `setoverrideAuthorizedBy(java.lang.String strIDNumber, FN objFamilyName, java.lang.String strGivenName, java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof, java.lang.String strSuffix, java.lang.String strPrefix, CWE objSourceTable, HD objAssigningAuthority, java.lang.String strNameTypeCode, java.lang.String strIdentifierCheckDigit, java.lang.String strCheckDigitScheme, java.lang.String strIdentifierTypeCode, HD objAssigningFacility, java.lang.String strNameRepresentationCode, CWE objNameContext, java.lang.String strNameAssemblyOrder, java.lang.String strEffectiveDate, java.lang.String strExpirationDate, java.lang.String strProfessionalSuffix, CWE objAssigningJurisdiction, CWE objAssigningAgencyOrDepratment, java.lang.String strSecurityCheck, java.lang.String strSecurityCheckScheme)` Sets the Override Authorized By.
    `void` | `setoverrideAuthorizedBy(XCN objoverrideAuthorizedBy)` Sets the Override Authorized By.
    `void` | `setoverrideComments(java.lang.String strOverrideComments)` Sets the Override Comments.
    `void` | `setoverrideComments(TX objoverrideComments)` Sets the Override Comments.
    `void` | `setoverrideEnteredBy(java.lang.String strIDNumber, FN objFamilyName, java.lang.String strGivenName, java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof, java.lang.String strSuffix, java.lang.String strPrefix, CWE objSourceTable, HD objAssigningAuthority, java.lang.String strNameTypeCode, java.lang.String strIdentifierCheckDigit, java.lang.String strCheckDigitScheme, java.lang.String strIdentifierTypeCode, HD objAssigningFacility, java.lang.String strNameRepresentationCode, CWE objNameContext, java.lang.String strNameAssemblyOrder, java.lang.String strEffectiveDate, java.lang.String strExpirationDate, java.lang.String strProfessionalSuffix, CWE objAssigningJurisdiction, CWE objAssigningAgencyOrDepratment, java.lang.String strSecurityCheck, java.lang.String strSecurityCheckScheme)` Sets the Override Entered By.
    `void` | `setoverrideEnteredBy(XCN objoverrideEnteredBy)` Sets the Override Entered By.
    `boolean` | `validate()` Validates HL7 Message objects .

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.segments.Segment

      `addUnRecognizedField, dumpSegment, getFields, getName, getUnrecognizedFields, moveToNextSegment, parse, removeDataElement, removeDataElement, serialize, setName, setUnRecognizedField, updateDataElement, updateDataElement, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### OVR

          public OVR()

  - ### Method Detail

    - #### getbusinessRuleOverrideType

          public CWE getbusinessRuleOverrideType()

      Retrieves the Business Rule Override Type. This specifies what type of business rule override is being performed.
      Returns:
        CWE - Business Rule Override Type.

    - #### getbusinessRuleOverrideCode

          public CWE getbusinessRuleOverrideCode()

      Retrieves the Business Rule Override Code. This specifies the reason for the business rule override.
      Returns:
        CWE - Business Rule Override Code.

    - #### getoverrideComments

          public TX getoverrideComments()

      Retrieves the Override Comments. This specifies descriptive comments detailing the circumstances of the override.
      Returns:
        TX - Override Comments.

    - #### getoverrideEnteredBy

          public XCN getoverrideEnteredBy()

      Retrieves the Override Entered By. This specifies the user entering the override in the system.
      Returns:
        XCN - Override Entered By.

    - #### getoverrideAuthorizedBy

          public XCN getoverrideAuthorizedBy()

      Retrieves the Override Authorized By. This specifies the health services provider who accepts professional responsibility for overriding the business rule.
      Returns:
        XCN - Override Authorized By.

    - #### setbusinessRuleOverrideType

          public void setbusinessRuleOverrideType(java.lang.String strIdentifier,
                                         java.lang.String strText,
                                         java.lang.String strNameOfCodingSystem,
                                         java.lang.String strAlternateIdentifier,
                                         java.lang.String strAlternateText,
                                         java.lang.String strNameOfAlternateCodingSystem,
                                         java.lang.String strCodingSystemVersionID,
                                         java.lang.String strAlternateCodingSystemVersionId,
                                         java.lang.String strOriginalText,
                                         java.lang.String strSecondAlternateIdentifier,
                                         java.lang.String strSecondAlternateText,
                                         java.lang.String strNameofSecondAlternateCodingSystem,
                                         java.lang.String strSecondAlternateCodingSystemVersionID,
                                         java.lang.String strCodingSystemOID,
                                         java.lang.String strValueSetOID,
                                         java.lang.String strValueSetVersionID,
                                         java.lang.String strAlternateCodingSystemOID,
                                         java.lang.String strAlternateValueSetOID,
                                         java.lang.String strAlternateValueSetVersionID,
                                         java.lang.String strSecondAlternateCodingSystemOID,
                                         java.lang.String strSecondAlternateValueSetOID,
                                         java.lang.String strSecondAlternateValueSetVersionID)

      Sets the Business Rule Override Type. This specifies what type of business rule override is being performed.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setbusinessRuleOverrideType

          public void setbusinessRuleOverrideType(CWE objbusinessRuleOverrideType)

      Sets the Business Rule Override Type. This specifies what type of business rule override is being performed.
      Parameters:
        `objbusinessRuleOverrideType` - object of Business Rule Override Type.

    - #### setbusinessRuleOverrideCode

          public void setbusinessRuleOverrideCode(java.lang.String strIdentifier,
                                         java.lang.String strText,
                                         java.lang.String strNameOfCodingSystem,
                                         java.lang.String strAlternateIdentifier,
                                         java.lang.String strAlternateText,
                                         java.lang.String strNameOfAlternateCodingSystem,
                                         java.lang.String strCodingSystemVersionID,
                                         java.lang.String strAlternateCodingSystemVersionId,
                                         java.lang.String strOriginalText,
                                         java.lang.String strSecondAlternateIdentifier,
                                         java.lang.String strSecondAlternateText,
                                         java.lang.String strNameofSecondAlternateCodingSystem,
                                         java.lang.String strSecondAlternateCodingSystemVersionID,
                                         java.lang.String strCodingSystemOID,
                                         java.lang.String strValueSetOID,
                                         java.lang.String strValueSetVersionID,
                                         java.lang.String strAlternateCodingSystemOID,
                                         java.lang.String strAlternateValueSetOID,
                                         java.lang.String strAlternateValueSetVersionID,
                                         java.lang.String strSecondAlternateCodingSystemOID,
                                         java.lang.String strSecondAlternateValueSetOID,
                                         java.lang.String strSecondAlternateValueSetVersionID)

      Sets the Business Rule Override Code. This specifies the reason for the business rule override.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setbusinessRuleOverrideCode

          public void setbusinessRuleOverrideCode(CWE objbusinessRuleOverrideCode)

      Sets the Business Rule Override Code. This specifies the reason for the business rule override.
      Parameters:
        `objbusinessRuleOverrideCode` - object of Business Rule Override Code.

    - #### setoverrideComments

          public void setoverrideComments(java.lang.String strOverrideComments)

      Sets the Override Comments. This specifies descriptive comments detailing the circumstances of the override.
      Parameters:
        `strOverrideComments` - Used for Override Comments.

    - #### setoverrideComments

          public void setoverrideComments(TX objoverrideComments)

      Sets the Override Comments. This specifies descriptive comments detailing the circumstances of the override.
      Parameters:
        `objoverrideComments` - object of Override Comments.

    - #### setoverrideEnteredBy

          public void setoverrideEnteredBy(java.lang.String strIDNumber,
                                  FN objFamilyName,
                                  java.lang.String strGivenName,
                                  java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof,
                                  java.lang.String strSuffix,
                                  java.lang.String strPrefix,
                                  CWE objSourceTable,
                                  HD objAssigningAuthority,
                                  java.lang.String strNameTypeCode,
                                  java.lang.String strIdentifierCheckDigit,
                                  java.lang.String strCheckDigitScheme,
                                  java.lang.String strIdentifierTypeCode,
                                  HD objAssigningFacility,
                                  java.lang.String strNameRepresentationCode,
                                  CWE objNameContext,
                                  java.lang.String strNameAssemblyOrder,
                                  java.lang.String strEffectiveDate,
                                  java.lang.String strExpirationDate,
                                  java.lang.String strProfessionalSuffix,
                                  CWE objAssigningJurisdiction,
                                  CWE objAssigningAgencyOrDepratment,
                                  java.lang.String strSecurityCheck,
                                  java.lang.String strSecurityCheckScheme)

      Sets the Override Entered By. This specifies the user entering the override in the system.
      Parameters:
        `strIDNumber` - Refers to the coded ID according to a user-defined table
        `objFamilyName` - Specifies the surname of a person.
        `strGivenName` - Specifies First name.
        `strSecondAndFurtherGivenNamesOrInitialsThereof` - Specifies multiple middle names that may be included by separating them with spaces.
        `strSuffix` - Used to specify a name suffix (e.g., Jr. or III).
        `strPrefix` - Used to specify a name prefix (e.g., Dr.).
        `objSourceTable` - Used as the HL7 identifier for the user-defined table of values for this component. [Refer User-defined Table 0297 - CN ID.]
        `objAssigningAuthority` - Specifies a unique identifier of the system (or organization or agency of department) that creates the data. [Refer User-defined Table 0363 - Assigning authority]
        `strNameTypeCode` - Specifies a code that represents the type of name.
        `strIdentifierCheckDigit` - Specifies part of the identifying number used in the sending application.
        `strCheckDigitScheme` - Specifies the code identifying the check digit scheme employed.[Refer HL7 Table 0061 - Check digit scheme].
        `strIdentifierTypeCode` - Specifies A code corresponding to the type of identifier.[Refer HL7 Table 0203 - Identifier type].
        `objAssigningFacility` - Specifies the place or location identifier where the identifier was first assigned to the person
        `strNameRepresentationCode` - Provides an indication of the representation provided by the data item.
        `objNameContext` - Designates the context in which a name is used. [Refer User-defined Table 0448 ]
        `strNameAssemblyOrder` - Specifies a code that represents the preferred display order of the components of this person name. Suggested values are G,F[Refer table 0444.]
        `strEffectiveDate` - Specifies the first date, if known, on which the address is valid and active.
        `strExpirationDate` - Specifies the last date, if known, on which the address is valid and active.
        `strProfessionalSuffix` - Used to specify an abbreviation, or a string of abbreviations, denoting qualifications that support the person's profession, (e.g., licenses).
        `objAssigningJurisdiction` - Specifies the geo-political body that assigned the identifier.
        `objAssigningAgencyOrDepratment` - Specifies the agency or department that assigned the identifier
        `strSecurityCheck` - Specifies the version code that may be assigned to the person identifier
        `strSecurityCheckScheme` - Specifies the check digit scheme.

    - #### setoverrideEnteredBy

          public void setoverrideEnteredBy(XCN objoverrideEnteredBy)

      Sets the Override Entered By.
      Parameters:
        `objoverrideEnteredBy` - object of Override Entered By.

    - #### setoverrideAuthorizedBy

          public void setoverrideAuthorizedBy(java.lang.String strIDNumber,
                                     FN objFamilyName,
                                     java.lang.String strGivenName,
                                     java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof,
                                     java.lang.String strSuffix,
                                     java.lang.String strPrefix,
                                     CWE objSourceTable,
                                     HD objAssigningAuthority,
                                     java.lang.String strNameTypeCode,
                                     java.lang.String strIdentifierCheckDigit,
                                     java.lang.String strCheckDigitScheme,
                                     java.lang.String strIdentifierTypeCode,
                                     HD objAssigningFacility,
                                     java.lang.String strNameRepresentationCode,
                                     CWE objNameContext,
                                     java.lang.String strNameAssemblyOrder,
                                     java.lang.String strEffectiveDate,
                                     java.lang.String strExpirationDate,
                                     java.lang.String strProfessionalSuffix,
                                     CWE objAssigningJurisdiction,
                                     CWE objAssigningAgencyOrDepratment,
                                     java.lang.String strSecurityCheck,
                                     java.lang.String strSecurityCheckScheme)

      Sets the Override Authorized By. This specifies the health services provider who accepts professional responsibility for overriding the business rule.
      Parameters:
        `strIDNumber` - Refers to the coded ID according to a user-defined table
        `objFamilyName` - Specifies the surname of a person.
        `strGivenName` - Specifies First name.
        `strSecondAndFurtherGivenNamesOrInitialsThereof` - Specifies multiple middle names that may be included by separating them with spaces.
        `strSuffix` - Used to specify a name suffix (e.g., Jr. or III).
        `strPrefix` - Used to specify a name prefix (e.g., Dr.).
        `objSourceTable` - Used as the HL7 identifier for the user-defined table of values for this component. [Refer User-defined Table 0297 - CN ID.]
        `objAssigningAuthority` - Specifies a unique identifier of the system (or organization or agency of department) that creates the data. [Refer User-defined Table 0363 - Assigning authority]
        `strNameTypeCode` - Specifies a code that represents the type of name.
        `strIdentifierCheckDigit` - Specifies part of the identifying number used in the sending application.
        `strCheckDigitScheme` - Specifies the code identifying the check digit scheme employed.[Refer HL7 Table 0061 - Check digit scheme].
        `strIdentifierTypeCode` - Specifies A code corresponding to the type of identifier.[Refer HL7 Table 0203 - Identifier type].
        `objAssigningFacility` - Specifies the place or location identifier where the identifier was first assigned to the person
        `strNameRepresentationCode` - Provides an indication of the representation provided by the data item.
        `objNameContext` - Designates the context in which a name is used. [Refer User-defined Table 0448 ]
        `strNameAssemblyOrder` - Specifies a code that represents the preferred display order of the components of this person name. Suggested values are G,F[Refer table 0444.]
        `strEffectiveDate` - Specifies the first date, if known, on which the address is valid and active.
        `strExpirationDate` - Specifies the last date, if known, on which the address is valid and active.
        `strProfessionalSuffix` - Used to specify an abbreviation, or a string of abbreviations, denoting qualifications that support the person's profession, (e.g., licenses).
        `objAssigningJurisdiction` - Specifies the geo-political body that assigned the identifier.
        `objAssigningAgencyOrDepratment` - Specifies the agency or department that assigned the identifier
        `strSecurityCheck` - Specifies the version code that may be assigned to the person identifier
        `strSecurityCheckScheme` - Specifies the check digit scheme.

    - #### setoverrideAuthorizedBy

          public void setoverrideAuthorizedBy(XCN objoverrideAuthorizedBy)

      Sets the Override Authorized By.
      Parameters:
        `objoverrideAuthorizedBy` - object of Override Authorized By.

    - #### validate

          public boolean validate()
                           throws InvalidSegmentException

      Validates HL7 Message objects . Validate method checks for validation each and every segments in side the Message object against specified message Structure. Validation chcecks include optionality of segment or group. It also verifies the number of times segment or group is repeated in message. e.g {PSH} while parsing PSH segment validate method will check for its mandatory presence. [PSH] in this case validate will throw exception if one tries to enter more than one PSH segment.
      Specified by:
        `validate` in interface `ISegment`
      Overrides:
        `validate` in class `Segment`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidSegmentException` - Throws when Segment Validation fails.